/*
 * @Descripttion: 
 * @version: 
 * @Author: kBank
 * @Date: 2022-10-24 10:45:39
 */
import { login, logout, getInfo } from '@/api/user'
import { getToken, setToken, removeToken } from '@/utils/auth'
import { resetRouter } from '@/router'

const getDefaultState = () => {
  return {
    token: getToken(),
    name: '',
    avatar: '',
    user: '',
    getUser: '',
    buttons: []
  }
}

const state = getDefaultState()

const mutations = {
  RESET_STATE: (state) => {
    Object.assign(state, getDefaultState())
  },
  SET_TOKEN: (state, token) => {
    state.token = token
  },
  SET_NAME: (state, name) => {
    state.name = name
  },
  SET_AVATAR: (state, avatar) => {
    state.avatar = avatar
  },
  SET_USER: (state, user) => {
    state.user = user
  },
  SET_BTN: (state, buttons) => {
    state.buttons = buttons
  },
  // SET_CURRENCY:(state,currency)=>{
  //   state.currency = currency
  // },
  SET_USERS: (state, data) => {
    state.getUser = data

  },
}

const actions = {
  // user login
  login({ commit }, userInfo) {
    const { username, password, code, uuid ,smsCode} = userInfo
    return new Promise((resolve, reject) => {
      login({ username: username.trim(), password: password, code: code, uuid: uuid,smsCode:smsCode }).then(response => {
        const { data } = response
        localStorage.setItem("systemItem", data.system_type||2)
        commit('SET_TOKEN', data.access_token)
        setToken(data.access_token)
        resolve()
      }).catch(error => {
        reject(error)
      })
    })
  },

  // get user info
  getInfo({ commit, state }) {
    return new Promise((resolve, reject) => {
      getInfo(state.token).then(response => {
        const data = response
        if (!data) {
          return reject('Verification failed, please Login again.')
        }

        // const { name, avatar } = data

        // commit('SET_NAME', name)
        // commit('SET_AVATAR', avatar)
        commit('SET_USER', data.user)
        commit('SET_BTN', data.buttons)
        localStorage.setItem('buttons', JSON.stringify(data.buttons))
        localStorage.setItem('userInfo', JSON.stringify(data.user))
        localStorage.setItem('userAll', JSON.stringify(data))
        // console.log('🌈123',data.currency)
        // commit('SET_CURRENCY',data.currency)
        commit('SET_USERS', data)
        resolve(data)
      }).catch(error => {
        reject(error)
      })
    })
  },

  // user logout
  LogOut({ commit, state }) {
    return new Promise((resolve, reject) => {
      logout(state.token).then(() => {
        removeToken() // must remove  token  first
        resetRouter()
        commit('RESET_STATE')
        resolve()
      }).catch(error => {
        reject(error)
      })
    })
  },

  // remove token
  resetToken({ commit }) {
    return new Promise(resolve => {
      removeToken() // must remove  token  first
      commit('RESET_STATE')
      resolve()
    })
  }
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}

